package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {


    public ArrayUtility(T[] arr) {
        this.arr = arr;
    }

    T[] arr;




    public int getNumberOfOccurrences(T element){
        int count = 0;

        for(T el: arr){
            if(el==element){
                count++;
            }

        }
        return count;
    }

    public Object[] merge(T[]arr1 ){
        Object[]mergeArr = new Object[arr.length + arr1.length];
        int counter =0;
        for(T el : arr){
            mergeArr[counter] = el;
            counter++;
        }
        for(T el : arr1){
            mergeArr[counter] = el;
            counter++;
        }
        return mergeArr;
    }

    public int countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate){
        ArrayUtility arrayUtility = new ArrayUtility(merge(arrayToMerge));
        return arrayUtility.getNumberOfOccurrences(valueToEvaluate);

    }

    public T getMostCommonFromMerge(T[] arrayToMerge){
        ArrayUtility arrayUtility = new ArrayUtility(merge(arrayToMerge));
        int tempCount = 0;
        T mostCommonObj = null;
        for(Object el: arrayUtility.arr){
            if(getNumberOfOccurrences((T)el)>tempCount){
                tempCount=getNumberOfOccurrences((T) el);
                mostCommonObj=(T)el;
            }
        }
        return mostCommonObj;
    }

    public T[] removeValue(T valueToRemove){

        ArrayList<T> arr1 = new ArrayList<>();

        for(int i =0; i< arr.length;i++){
            if(!arr[i].equals(valueToRemove)){
                arr1.add(arr[i]);
            }
        }
        int newLength = arr1.size();

        arr = (T[]) Array.newInstance(arr.getClass().getComponentType(), newLength);

        return arr1.toArray(arr);
    }
}
